### Définition de contraintes de construction

Une règle de construction détermine les modalités de construction de la géométrie d’entités par rapport à d’autres entités dites de référence.

La fonction **Ajouter une contrainte de construction** accessible via le menu contextuel permet de créer une nouvelle contrainte de construction.

![](../../Ressources/Images/ajout_contrainte_construction_238x154.png)

#### Caractéristiques de la contrainte de construction

L’interface **Caractéristiques de la contrainte de construction** permet de définir des contraintes de construction de la géométrie d’un type d’entité par rapport à la géométrie d’un type d’entité de référence.

![](../../Ressources/Images/contrainte_construction.png)

4 types de **contraintes de construction** sont possibles : selon le type de contrainte sélectionné, le résultat du contrôle peut différer.

- **Appui sur Vertex** : tous les vertex des entités à contrôler doivent être égaux aux vertex des entités de référence.

<span style="color: #943a99;">==> Erreur retournée : E0051 (Erreur de contrainte de construction stricte - vertex).</span>

**- Appui strict sur segment** : tous les segments de l’entité à contrôler doivent être égaux aux segments des entités de référence.

<span style="color: #943a99;">==> Erreur retournée : E0050 (Erreur de contrainte de construction stricte - segment).</span>

**- Appui sur segment, partie de segment** : tous les segments du type d’entité à contrôler ne doivent pas croiser ou être contenus dans le type d’entité de référence.

<span style="color: #943a99;">==> Erreur retournée : E0052 (Erreur de contrainte de construction permissive - segment).</span>

- **Appui sur polygone ou partie de polygone** : les polygones des entités de référence ne doivent pas être découpés par les polygones des entités à contrôler.

<span style="color: #943a99;">==> Erreur retournée : E0054 (Erreur de contrainte de construction permissive - polygone).</span>

[En savoir plus sur les règles de construction et obtenir des exemples.](../../04-ContraintesRessources/03.03.ContraintesConstruction.html#regles-de-construction-et-exemples)

##### Règle de validation des erreurs

Une règle de validation peut être spécifiée dans le cas d’une contrainte relative à un polygone de référence. Qualigéo valide les erreurs de construction en fonction de la règle définie par une fonction fme_evaluate.

![](../../Ressources/Images/contrainte_construction_regeml_validation.png)

[En savoir plus sur les contraintes de construction et les règles de validation.](../../04-ContraintesRessources/03.03.ContraintesConstruction.html#regle-de-validation-des-erreurs)
