# Les contraintes de construction dans Qualigéo

<a name="Règles_construction"></a>

Une contrainte de construction permet de définir des règles de construction de la géométrie d’un type d’entité par rapport à la géométrie d’un type d’entité de référence.

## Règles de construction et exemples

![](../Ressources/Images/legende_179x86.png)

<style type="text/css">
.tg  {border-collapse:collapse;border-spacing:0;}
.tg td{border-color:black;border-style:solid;border-width:1px;font-family:Arial, sans-serif;font-size:14px;
  overflow:hidden;padding:10px 20px;word-break:normal;}
.tg th{border-color:black;border-style:solid;border-width:1px;font-family:Arial, sans-serif;font-size:14px;
  font-weight:normal;overflow:hidden;padding:10px 20px;word-break:normal;}
.tg .tg-2eas{background-color:#eae8e8;border-color:#c0c0c0;text-align:left;vertical-align:top}
.tg .tg-hjsu{background-color:#923288;border-color:#c0c0c0;color:#ffffff;text-align:left;vertical-align:top}
.tg .tg-8p16{background-color:#ffffff;border-color:#c0c0c0;color:#000000;text-align:left;vertical-align:top}
.tg .tg-fzdr{border-color:#c0c0c0;text-align:center;vertical-align:top}
.tg .tg-wo29{border-color:#c0c0c0;text-align:left;vertical-align:top}
.tg .tg-aqga{background-color:#eae8e8;border-color:#c0c0c0;text-align:center;vertical-align:top}
</style>
<table class="tg">
  <tr>
    <th class="tg-hjsu">Exemple<span style="color:rgb(146, 50, 136)">eeeeeeeeeeeee</span><br></th>
    <th class="tg-hjsu">Appui sur vertex<br></th>
    <th class="tg-hjsu">Appui sur segment<br></th>
    <th class="tg-hjsu">Appui sur segment, partie de segment<br></th>
    <th class="tg-hjsu">Appui sur polygone, partie de polygone<br></th>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/1_150x110.png" style="width: 150;height: 110;" /></td>
    <td class="tg-fzdr">Construction valide : tous les vertex sont égaux</td>
    <td class="tg-wo29">Construction valide : tous les segments sont égaux</td>
    <td class="tg-wo29">Construction valide : aucun segment à contrôler ne croise ou ne contient un segment de référence</td>
    <td class="tg-wo29">Construction valide : aucune parcelle de référence n'est découpée par la zone d'analyse</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/2_172x120.png" style="width: 172;height: 120;" /></td>
    <td class="tg-aqga">Construction non valide : Segment [AB] en erreur : un vertex manquant<br></td>
    <td class="tg-2eas">Construction non valide : Segment [AB] n’est  égal à aucun segment de référence</td>
    <td class="tg-2eas">Construction non valide : le segment [AB]contient des segments de référence</td>
    <td class="tg-2eas">Construction valide : aucune parcelle de référence n’est découpée par la zone d’analyse</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/3_157x112.png" style="width: 157;height: 112;" /></td>
    <td class="tg-fzdr">Construction non valide : le vertex B est en trop</td>
    <td class="tg-wo29">Construction non valide : les segment [AB] et [BC] ne sont égaux à aucun segment de référence</td>
    <td class="tg-wo29">Construction  valide : les segments [AB] et [BC] ne croisent  pas de segment de référence et  n’en  contiennent pas</td>
    <td class="tg-wo29">Construction valide : aucune parcelle de référence n’est découpée par la zone d’analyse</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/4_163x119.png" style="width: 163;height: 119;" /></td>
    <td class="tg-aqga">Construction valide: tous les vertex sont égaux</td>
    <td class="tg-2eas">Construction non valide segment [DE] en erreur</td>
    <td class="tg-2eas">Construction valide : le segment [DE] ne croise pas (il touche), ni ne contient  de  segment de référence<br></td>
    <td class="tg-2eas">Construction non valide : la parcelle 2 est découpée en 2 par le polygone à contrôler</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/5_155x125.png" style="width: 155;height: 125;" /></td>
    <td class="tg-wo29">Construction non valide : Les vertex B, C et D ne sont égaux à aucun vertex de référence</td>
    <td class="tg-fzdr">Construction non valide : les segments [AB], [BC] [CD] et [DE] ne sont égaux à aucun segment de référence</td>
    <td class="tg-wo29">Construction non valide : le segment [GH] croise deux segments de référence</td>
    <td class="tg-wo29">Construction non valide : les parcelles 1 et 2 sont découpées par le polygone à contrôler</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/6_178x78.png" style="width: 178;height: 78;" /></td>
    <td class="tg-2eas">Construction valide : tous les vertex sont égaux</td>
    <td class="tg-2eas">Construction non valide segments [AB]et [FE] en erreur</td>
    <td class="tg-aqga">Construction valide : les segments [AB] et [FE] ne croisent pas  de segments de référence (ils les touchent), et n’en contient aucun</td>
    <td class="tg-aqga">Construction valide : aucune parcelle n’est découpée par la zone d’étude</td>
  </tr>
  <tr>
    <td class="tg-8p16"><img src="..\_images/7_126x137.png" style="width: 126;height: 137;" /></td>
    <td class="tg-wo29">Construction non valide : aucun vertex n’est égal à un aucun vertex de référence</td>
    <td class="tg-wo29">Construction non valide : aucun segment n’est égal à un aucun segment de référence</td>
    <td class="tg-wo29">Construction valide : aucun segment à contrôler n’intersecte ni n’est contenu dans un segment de référence</td>
    <td class="tg-wo29">Construction valide : la parcelle 1 n’est pas découpée par la zone d’analyse et est totalement incluse<br></td>
  </tr>
</table>


### Règle de validation des erreurs

Une règle de validation permet à Qualigéo de valider des erreurs de construction en fonction d’une règle définie par une fonction.

Deux attributs **area_ref_ft** correspondant à la superficie du polygone de référence et **_area_ft**, correspondant à la superficie des polygones à contrôler permettent d’intégrer des règles relatives aux surfaces découpées.

Par exemple, une fonction peut être utilisée pour indiquer qu’une erreur doit être générée si la superficie des polygones découpés est inférieure à une valeur précise ou à un certain pourcentage de la superficie d’origine.

L’exemple ci-dessous illustre le cas de découpage de parcelles (type d’entité de référence) par une zone urbaine (type d’entité à contrôler). La fonction ci-dessous indique que si la superficie des parcelles découpées est inférieure à 3% de la superficie totale de la parcelle d’origine ou si elle est inférieure à 2 m² alors aucune une erreur ne doit être générée. Au-delà de 3% de la superficie totale ou supérieure à 2 m², une erreur de construction est donc détectée.

![](../Ressources/Images/construction_fonction.png)

**NB** : les entités découpées se trouvant à l’intérieur de la zone d’analyse récupèrent l’attributs \_area\_ft de cette dernière, en revanche les entités découpées se trouvant à l’extérieur de la zone ne le récupèrent pas.

La fonction à saisir dans la règle de validation peut contenir n’importe quelle formule exploitable par le Transformer ExpressionEvaluator de FME et renvoyant les valeurs 0 (faux) ou 1 (vrai).

#### Fonctions communément utilisées

@Area(1) : renvoie la superficie de l’objet

@Length(2,1) : renvoie le périmètre de l’objet

@Value(attr) : renvoie la valeur de l’attribut "attr"

Attention, une erreur dans la formule risque de produire une erreur irrécupérable qui empêchera la réalisation du contrôle.

Toutes les fonctions disponibles sont décrites dans le document de référence : "FME functions and factories" de FME.

#### Utiliser la précision comme tolérance

Pour permettre la comparaison stricte des géométries et tenir compte d’écarts minimes dus au format de stockage ou à la reprojection, il convient d’utiliser la précision comme tolérance pour ne pas considérer comme des erreurs les décalages observés inférieurs à cette dernière.                    
