# Administration de Qualigéo

L’interface **Administration** permet de visualiser et configurer les utilisateurs de Qualigéo, les formats des jeux de données, les styles pour la génération de rapports ainsi que les systèmes de coordonnées. La représentation se fait de manière arborescente, où chaque nœud possède son propre formulaire de saisie.

![](../Ressources/Images/Interface_administration_533x359.png)


## Ajout et Gestion des Formats

### Liste des formats

La liste des formats contient tous les formats définis, classés par type de source (fichier, répertoire ou base de données).

La sélection du nœud **Formats** affiche un tableau de tous les formats exploitables par Qualigéo.

![](../Ressources/Images/liste_formats.PNG)

Un double clic sur un format permet d’afficher son formulaire d’édition. Le bouton **Supprimer** permet de supprimer les formats cochés.

### Source Type

Les formats sont organisés selon le type de source :

*   FILE
*   DIRECTORY
*   DATABASE

### Édition de Format

Un clic sur le nom d’un format permet d’afficher le formulaire de création/édition d’un format.

![](../Ressources/Images/interface_format.PNG)

Pour définir un format classique ou personnalisé, les informations suivantes sont nécessaires :

*   **Id format**, nom du format tel qu’il apparaît dans la colonne "Nom du court" dans la Galerie des formats de FME.
*   **Format**, le nom du format qui apparaîtra dans la liste dans Qualigéo. Il correspond au champs "Description" de la Galerie des formats de FME.
*   **Type**, le type des données (2D, 3D ou NON_SPATIAL).
*   **Source Type**, le type du jeu de données (FILE, DIRECTORY, DATABASE).
*   **Extensions**, la liste des extensions utilisées par le schéma. Les extensions s’écrivent comme sur l’exemple précédent (*.extension) et sont séparées par un "|".
*   L’option **"Utilisable pour l’export des contrôles"** indique si un rapport peut être généré ou non dans ce format.

![](../Ressources/Images/attention.png) **L’intégration de [format personnalisé](../04-ContraintesRessources/05.05.UtilisationFormatsPersonnalises.html) se fait de la même façon qu’un format classique, en renseignant l’ensemble des champs. Il est conseillé d’insérer la même valeur pour les champs "Id Format’ et "Format".**

[En savoir plus sur les formats personnalisés dans Qualigéo et obtenir des exemples.](../04-ContraintesRessources/05.05.UtilisationFormatsPersonnalises.html)

---

## Ajout et Gestion des utilisateurs

### Liste des utilisateurs

La liste des utilisateurs contient tous les utilisateurs de la base.

Un clic sur le nœud Utilisateurs affiche la liste des utilisateurs et leur rôle respectif.

![](../Ressources/Images/liste_users.PNG)

Un double clic sur un utilisateur permet d’afficher le formulaire lié à celui-ci. Le bouton **Supprimer** permet de supprimer les utilisateurs cochés.

### Rôles

La liste des utilisateurs regroupe ceux-ci en fonction de leur **Rôle** :

*   **qual_administrator** : administrateur de Qualigéo. Il accède à l’intégralité des fonctionnalités et notamment aux fonctions d’administration telles que la gestion des utilisateurs et l’exploitation de l’application.

*   **qual_designer** : utilisateur qui édite un schéma de contraintes. Il accède à l’intégralité des schémas de contraintes publics qu’il en soit le concepteur ou non, et il peut les modifier. Il peut exécuter un contrôle sur l’intégralité des schémas publics et accède à l’ensemble des analyses.

*   **qual_controler** : utilisateur qui lance un contrôle et accède à son analyse. Il accède à tous les schémas publics mais ne peut pas les modifier. Il accède à l’intégralité des analyses.

*   **Aucun** : pour tous les utilisateurs de la base de données n’ayant aucun rôle sur la base Qualigéo.

Un menu contextuel est associé à chacun de ces nœuds permettant d’ajouter un utilisateur avec le rôle spécifié.

[En savoir plus sur la création de comptes et de rôles](../04-ContraintesRessources/05.04.CreationComptesRoles.html)

### Ajouter un Utilisateur

Le nœud utilisateur permet d’afficher le formulaire correspondant à l’utilisateur sélectionné.

![](../Ressources/Images/interface_user.PNG)

Pour définir un utilisateur, il faut définir les informations suivantes :

*   **Utilisateur** : le nom de l’utilisateur.
*   **Mot de passe** : le mot de passe à saisir deux fois. Lors de la modification d’un utilisateur, si vous souhaitez modifier sont mot de passe, cliquer sur **Modifier**.
*   **Rôle** : le rôle de l’utilisateur sur la base Qualigéo.
*   **Actif**, si cette case est décochée, l’utilisateur ne possède aucun rôle sur la base Qualigéo.

#### Menu contextuel

Un menu contextuel permet de supprimer un utilisateur, de le désactiver, ou bien de modifier son mot de passe.

---

## Personnalisation des rapports HTML

La personnalisation des rapports permet de gérer le style du rendu HTML. Un style par défaut est proposé, mais il est possible de créer de nouveaux styles nommés en renseignant les paramètres suivants :

*   le nom du style,
*   la couleur du style,
*   le logo (affiché en bas à droite du rapport).

![](../Ressources/Images/xsl_619x390.png)

## Ajout et gestion de systèmes de coordonnées

L’interface Caractéristique du système de coordonnées accessible via le menu contextuel du nœud Systèmes de coordonnées ![](../Ressources/Images/noeud_syscoor.png) permet l’ajout de système de coordonnées.

![](../Ressources/Images/syst_coord.png)

L’administrateur définit **Id Coordsys**, l’identifiant du système de coordonnées tel qu’il est défini dans FME. Il indique ensuite le **Format**, c’est à dire la valeur à afficher dans l’interface de Qualigéo (listes déroulantes).
